Index: /DCWoRMS/trunk/src/schedframe/scheduling/manager/tasks/AbstractJobRegistry.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/manager/tasks/AbstractJobRegistry.java	(revision 480)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/manager/tasks/AbstractJobRegistry.java	(revision 481)
@@ -13,18 +13,16 @@
 
 
-public abstract class AbstractJobRegistry /*extends ConcurrentHashMap<String, Job> */implements JobRegistry, Cloneable{
+public abstract class AbstractJobRegistry /*extends ConcurrentHashMap<String, Job>*/ implements JobRegistry, Cloneable{
 	
 	private static final long serialVersionUID = 8409060063583755824L;
+
 	
-	private static Log log = LogFactory.getLog(AbstractJobRegistry.class);
-	
-	protected static final ConcurrentHashMap<String, Job> jobs = new ConcurrentHashMap<String, Job>();
+	protected static final ConcurrentHashMap<String, JobInterface<?>> jobs = new ConcurrentHashMap<String, JobInterface<?>>();
 	
 	protected AbstractJobRegistry(){
-		//log.warn("Methods from JobRegistry interface are not implemented.");
 	}
 	
 	public boolean addJob(JobInterface<?> job) {
-		jobs.put(job.getId(), (Job) job);
+		jobs.put(job.getId(),  job);
 		return true;
 	}
@@ -32,5 +30,5 @@
 	public boolean addTask(TaskInterface<?> task) {
 		if(jobs.containsKey(task.getJobId())){
-			jobs.get(task.getJobId()).add((Task)task);
+			getJob(task.getJobId()).add((Task)task);
 			return true;
 		} else {
@@ -39,15 +37,11 @@
 	}
 
-	public Job getJob(String jobId){
+	public JobInterface<?> getJobInfo(String jobId) {
 		return jobs.get(jobId);
 	}
-	
-	public JobInterface<?> getJobInfo(String jobID) {
-		return jobs.get(jobID);
-	}
 
-	public TaskInterface<?> getTaskInfo(String jobID, String taskId) {
+	public TaskInterface<?> getTaskInfo(String jobId, String taskId) {
 		Task task = null;
-		Job job = jobs.get(jobID);
+		Job job = getJob(jobId);
 		
 		if(job == null)
@@ -57,18 +51,11 @@
 			task = job.getTask(taskId);
 		} catch (NoSuchFieldException e) {
-			log.error(e.getMessage());
 		}
 		return task;
 	}
 	
-	/*public List<JobInterface<?>> getActiveJobs() {
-		log.error("getActiveJobs() not implemented.");
-		return null;
+	public Job getJob(String jobId){
+		return (Job)jobs.get(jobId);
 	}
 
-	public List<TaskInterface<?>> getActiveTasks() {
-		log.error("getActiveTasks() not implemented.");
-		return null;
-	}*/
-
 }
Index: /DCWoRMS/trunk/src/schedframe/scheduling/TaskList.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/TaskList.java	(revision 481)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/TaskList.java	(revision 481)
@@ -0,0 +1,10 @@
+package schedframe.scheduling;
+
+import java.util.List;
+
+import schedframe.scheduling.tasks.TaskInterface;
+
+
+public interface TaskList extends List<TaskInterface<?>>{
+
+}
Index: /DCWoRMS/trunk/src/schedframe/scheduling/queue/TaskQueue.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/queue/TaskQueue.java	(revision 478)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/queue/TaskQueue.java	(revision 481)
@@ -1,13 +1,12 @@
 package schedframe.scheduling.queue;
 
-import gridsim.Gridlet;
+import gridsim.gssim.DCWormsTags;
 import gssim.schedframe.scheduling.queues.AbstractStatsSupportingQueue;
 
 import org.joda.time.DateTime;
 
-import schedframe.scheduling.tasks.WorkloadUnit;
+import schedframe.scheduling.tasks.TaskInterface;
 
-public class TaskQueue extends AbstractStatsSupportingQueue<WorkloadUnit> implements Queue<WorkloadUnit>{
-
+public class TaskQueue extends AbstractStatsSupportingQueue<TaskInterface<?>> implements Queue<TaskInterface<?>>{
 
 	private static final long serialVersionUID = 6576299222910508209L;
@@ -17,35 +16,30 @@
 	protected boolean supportReservation;
 	
-	
 	public TaskQueue (boolean supportReservation){
-		name = "Queue";
-		priority = 0;
+		this.name = "Queue";
+		this.priority = 0;
 		this.supportReservation = supportReservation;
-
 	}
 	
-	public boolean add(WorkloadUnit wu){
+	public boolean add(TaskInterface<?> task){
 		try {
-			wu.setStatus(Gridlet.QUEUED);
+			task.setStatus(DCWormsTags.QUEUED);
 		} catch(Exception e){
 			throw new RuntimeException(e);
 		}
-		//updateStats();
-		return super.add(wu);
+		return super.add(task);
 	}
 	
-	public void add(int pos, WorkloadUnit wu){
+	public void add(int pos, TaskInterface<?> task){
 		try {
-			wu.setStatus(Gridlet.QUEUED);
+			task.setStatus(DCWormsTags.QUEUED);
 		} catch(Exception e){
 			throw new RuntimeException(e);
 		}
-		//updateStats();
-		 super.add(pos, wu);
+		 super.add(pos, task);
 	}
 	
 	public DateTime getArrivalTime(int pos) throws IndexOutOfBoundsException {
-		//return get(pos).getSubmissionTimeToBroker();
-		return null;
+		return get(pos).getSubmissionTimeToBroker();
 	}
 
@@ -69,35 +63,3 @@
 		return supportReservation;
 	}
-	
-	
-	/*public boolean contains (WorkloadUnitInterface<?> wu) {
-		for(int i = 0; i< size();i++){
-			try {
-				if(get(i).getId().equals(wu.getId()))
-					return true;
-			} catch (NoSuchFieldException e) {
-				return false;
-			}
-		}
-		return false;
-	}
-	
-	public boolean remove (WorkloadUnitInterface<?> wu) {
-		boolean found = false;
-		int index = 0;
-		for(int i = 0; i< size() && !found;i++){
-			try {
-				if(get(i).getId().equals(wu.getId()))
-				{
-					found = true;
-					index = i;
-				}
-				
-			} catch (NoSuchFieldException e) {
-				return false;
-			}
-		}
-		remove(index);
-		return true;
-	}*/
 }
Index: /DCWoRMS/trunk/src/schedframe/scheduling/tasks/TaskInterface.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/tasks/TaskInterface.java	(revision 480)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/tasks/TaskInterface.java	(revision 481)
@@ -88,11 +88,5 @@
 	 */
 	public long getLength();
-	
-	/**
-	 * 
-	 * @param length measured in instructions.
-	 */
-	public void setLength(long length);
-	
+
 	/**
 	 * 
Index: /DCWoRMS/trunk/src/schedframe/scheduling/tasks/Job.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/tasks/Job.java	(revision 480)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/tasks/Job.java	(revision 481)
@@ -178,5 +178,5 @@
 	}
 	
-	public int getUserID(){
+	public int getUserId(){
 		return this.senderId;
 	}
Index: /DCWoRMS/trunk/src/schedframe/scheduling/tasks/WorkloadUnit.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/tasks/WorkloadUnit.java	(revision 480)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/tasks/WorkloadUnit.java	(revision 481)
@@ -8,5 +8,5 @@
 	public String getId();
 	
-	public int getUserID();
+	public int getUserId();
 	
 	public int getStatus();
Index: /DCWoRMS/trunk/src/schedframe/scheduling/plan/ScheduledTaskInterface.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/plan/ScheduledTaskInterface.java	(revision 478)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/plan/ScheduledTaskInterface.java	(revision 481)
@@ -4,5 +4,5 @@
 
 import schedframe.DescriptionContainer;
-import schedframe.scheduling.tasks.WorkloadUnit;
+import schedframe.scheduling.tasks.TaskInterface;
 
 public interface ScheduledTaskInterface<T> extends DescriptionContainer<T> {
@@ -190,7 +190,7 @@
 	
 
-	public ArrayList<AllocationInterface> getAllocations();
+	public ArrayList<AllocationInterface<?>> getAllocations();
 	
-	public WorkloadUnit getTask();
+	public TaskInterface<?> getTask();
 
 }
Index: /DCWoRMS/trunk/src/schedframe/scheduling/plan/SchedulingPlanInterface.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/plan/SchedulingPlanInterface.java	(revision 477)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/plan/SchedulingPlanInterface.java	(revision 481)
@@ -99,4 +99,4 @@
 
 
-	public ArrayList<ScheduledTaskInterface> getTasks();
+	public ArrayList<ScheduledTaskInterface<?>> getTasks();
 }
Index: /DCWoRMS/trunk/src/schedframe/scheduling/plan/impl/SchedulingPlan.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/plan/impl/SchedulingPlan.java	(revision 477)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/plan/impl/SchedulingPlan.java	(revision 481)
@@ -18,10 +18,10 @@
 	public SchedulingPlan(){
 		sp = new org.qcg.broker.schemas.schedulingplan.SchedulingPlan();
-		taskList = new ArrayList<ScheduledTaskInterface>();
+		taskList = new ArrayList<ScheduledTaskInterface<?>>();
 	}
 	
 	public SchedulingPlan(org.qcg.broker.schemas.schedulingplan.SchedulingPlan value){
 		sp = value;
-		taskList = new ArrayList<ScheduledTaskInterface>();
+		taskList = new ArrayList<ScheduledTaskInterface<?>>();
 	}
 	
@@ -106,7 +106,7 @@
 
 	
-	protected ArrayList<ScheduledTaskInterface> taskList;
+	protected ArrayList<ScheduledTaskInterface<?>> taskList;
 
-	public ArrayList<ScheduledTaskInterface> getTasks() {
+	public ArrayList<ScheduledTaskInterface<?>> getTasks() {
 
 		return this.taskList;
Index: /DCWoRMS/trunk/src/schedframe/scheduling/plan/impl/ScheduledTask.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/plan/impl/ScheduledTask.java	(revision 478)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/plan/impl/ScheduledTask.java	(revision 481)
@@ -6,12 +6,10 @@
 import org.exolab.castor.xml.MarshalException;
 import org.exolab.castor.xml.ValidationException;
+import org.qcg.broker.schemas.schedulingplan.types.AllocationStatus;
 
 import schedframe.scheduling.plan.AllocationInterface;
 import schedframe.scheduling.plan.ScheduledTaskInterface;
 import schedframe.scheduling.plan.ScheduledTimeInterface;
-import schedframe.scheduling.tasks.WorkloadUnit;
-
-
-import org.qcg.broker.schemas.schedulingplan.types.AllocationStatus;
+import schedframe.scheduling.tasks.TaskInterface;
 
 public class ScheduledTask implements ScheduledTaskInterface<org.qcg.broker.schemas.schedulingplan.Task> {
@@ -22,10 +20,10 @@
 	public ScheduledTask(){
 		t = new org.qcg.broker.schemas.schedulingplan.Task();
-		allocationList = new ArrayList<AllocationInterface>();
+		allocationList = new ArrayList<AllocationInterface<?>>();
 	}
 	
 	public ScheduledTask(org.qcg.broker.schemas.schedulingplan.Task value){
 		t = value;
-		allocationList = new ArrayList<AllocationInterface>();
+		allocationList = new ArrayList<AllocationInterface<?>>();
 	}
 	
@@ -178,17 +176,17 @@
 	
 
-	protected WorkloadUnit task;
-	protected ArrayList<AllocationInterface> allocationList;
+	protected TaskInterface<?> task;
+	protected ArrayList<AllocationInterface<?>> allocationList;
 
-	public ScheduledTask(WorkloadUnit task){
+	public ScheduledTask(TaskInterface<?> task){
 		this();
 		this.task = task;
 	}
 
-	public ArrayList<AllocationInterface> getAllocations() {
+	public ArrayList<AllocationInterface<?>> getAllocations() {
 		return this.allocationList;
 	}
 	
-	public WorkloadUnit getTask(){
+	public TaskInterface<?> getTask(){
 		return this.task;
 	}
Index: /DCWoRMS/trunk/src/schedframe/resources/computing/ComputingResource.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/resources/computing/ComputingResource.java	(revision 477)
+++ /DCWoRMS/trunk/src/schedframe/resources/computing/ComputingResource.java	(revision 481)
@@ -2,5 +2,5 @@
 
 import gridsim.GridSimTags;
-import gridsim.gssim.WormsTags;
+import gridsim.gssim.DCWormsTags;
 
 import java.util.ArrayList;
@@ -275,5 +275,5 @@
 			if(scheduler != null && (parent != null && scheduler != parent.getScheduler())/*scheduler.getResources().contains(this)*/){
 				String src = event.getSource() != null ? event.getSource() : name;
-				scheduler.sendInternal(GridSimTags.SCHEDULE_NOW, WormsTags.UPDATE, src);
+				scheduler.sendInternal(GridSimTags.SCHEDULE_NOW, DCWormsTags.UPDATE, src);
 			} else if(parent != null)
 				parent.getEventHandler().handleSchedulingEvent(event);
Index: /DCWoRMS/trunk/src/schedframe/resources/computing/ResourceFactory.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/resources/computing/ResourceFactory.java	(revision 477)
+++ /DCWoRMS/trunk/src/schedframe/resources/computing/ResourceFactory.java	(revision 481)
@@ -11,5 +11,5 @@
 import schedframe.scheduling.policy.local.LocalManagementSystem;
 import schedframe.scheduling.queue.TaskQueueList;
-import simulator.WormsConstants;
+import simulator.DCWormsConstants;
 
 
@@ -46,5 +46,5 @@
 			}
 			case LS: {
-				ms = new LocalManagementSystem(id, WormsConstants.MANAGEMENT_SYSTEM,
+				ms = new LocalManagementSystem(id, DCWormsConstants.MANAGEMENT_SYSTEM,
 						schedulingPlugin, execTimeEstimationPlugin, queues);
 				return new Scheduler(ms, type, managedResources);
@@ -52,5 +52,5 @@
 
 		default:{
-				ms = new LocalManagementSystem(id, WormsConstants.MANAGEMENT_SYSTEM,
+				ms = new LocalManagementSystem(id, DCWormsConstants.MANAGEMENT_SYSTEM,
 						schedulingPlugin, execTimeEstimationPlugin, queues);
 				return new Scheduler(ms, type, managedResources);
Index: /DCWoRMS/trunk/src/gssim/schedframe/scheduling/ExecTask.java
===================================================================
--- /DCWoRMS/trunk/src/gssim/schedframe/scheduling/ExecTask.java	(revision 477)
+++ /DCWoRMS/trunk/src/gssim/schedframe/scheduling/ExecTask.java	(revision 481)
@@ -10,8 +10,5 @@
 	public boolean expectSpecificResource(ResourceParameterName resourceName);	
 	public Object getExpectedSpecificResource(ResourceParameterName resourceName);
-	
-	//public void addToResPath(String resName);
-	//public String getResPath();
-	
+
 	public void visitResource(String resName);
 	public List<String> getVisitedResources();
Index: /DCWoRMS/trunk/src/gssim/schedframe/scheduling/plugin/local/DCWormsTimeOperations.java
===================================================================
--- /DCWoRMS/trunk/src/gssim/schedframe/scheduling/plugin/local/DCWormsTimeOperations.java	(revision 481)
+++ /DCWoRMS/trunk/src/gssim/schedframe/scheduling/plugin/local/DCWormsTimeOperations.java	(revision 481)
@@ -0,0 +1,25 @@
+package gssim.schedframe.scheduling.plugin.local;
+
+import org.joda.time.DateTime;
+
+import schedframe.scheduling.plugin.local.TimeOperations;
+
+public class DCWormsTimeOperations extends TimeOperations {
+
+	public DCWormsTimeOperations(){
+		this(0);
+	}
+	
+	public DCWormsTimeOperations(long timeDelta){
+		super(timeDelta);
+	}
+
+	/**
+	 * Get Calendar object representing current logic time
+	 * @return current time
+	 */
+	public DateTime getTime() {
+		return new DateTime();
+	}
+
+}
Index: /DCWoRMS/trunk/src/gssim/schedframe/scheduling/Executable.java
===================================================================
--- /DCWoRMS/trunk/src/gssim/schedframe/scheduling/Executable.java	(revision 480)
+++ /DCWoRMS/trunk/src/gssim/schedframe/scheduling/Executable.java	(revision 481)
@@ -2,5 +2,6 @@
 
 
-import gridsim.Gridlet;
+import gridsim.GridSim;
+import gridsim.gssim.DCWormsTags;
 
 import java.util.ArrayList;
@@ -9,8 +10,14 @@
 import java.util.Map;
 
+import org.apache.commons.lang.ArrayUtils;
 import org.joda.time.DateTime;
 import org.joda.time.DateTimeUtilsExt;
 import org.joda.time.ReadableDuration;
 
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.units.ProcessingElements;
+import schedframe.resources.units.StandardResourceUnitName;
+import schedframe.scheduling.ResourceHistoryItem;
+import schedframe.scheduling.UsedResourceList;
 import schedframe.scheduling.WorkloadUnitHandler;
 import schedframe.scheduling.manager.tasks.JobRegistryImpl;
@@ -25,42 +32,69 @@
  *
  */
-public class Executable extends Gridlet implements ExecTask{
+public class Executable implements ExecTask{
 
 	protected Task task;
 	protected String processesSetId;
 	
+	protected int status; 
+	protected double length;
+	protected Map<ResourceParameterName, Object> specificResources;
+	
+	protected String reservationId;
+	protected double completionPercentage;
+	
+	protected int estimatedDuration;
+	//TO DO remove and benefit from visitedResources
+	protected String schedName;
+	protected UsedResourceList<ResourceHistoryItem> usedResources;
+	//TO DO consider removing
 	protected List<String> visitedResources;
 
+	protected double submissionTime;
+    protected double arrivalTime;
+	protected double execStartTime ;
+    protected double totalCompletionTime; 
+	protected double finishTime; 
 	
 	public Executable(Task t){
-		super(0, 0, 0, 0);
 		this.task = t;
-		super.gridletID_ = (t.getJobId() + "_" + t.getId()).hashCode();
-		reservationId = null;
+		this.status = DCWormsTags.CREATED;
+		
+		this.usedResources = new UsedResourceList<ResourceHistoryItem>();
 		this.visitedResources = new ArrayList<String>();
-		setUserID(task.getSenderId());
+		init();
 	}
 	
 	public Executable(Task t, AbstractProcesses procesesSet){
-		super(0, 0, 0, 0);
 		this.task = t;
+		this.status = DCWormsTags.CREATED;
 		this.processesSetId = procesesSet.getId(); 
-		super.gridletID_ = (t.getJobId() + "_" + t.getId() + "_" + processesSetId).hashCode();
+		
+		this.usedResources = new UsedResourceList<ResourceHistoryItem>();
 		this.visitedResources = new ArrayList<String>();
-		setUserID(task.getSenderId());
-	}
-	
-	public DateTime getExecutionEndTime() throws NoSuchFieldException {
-		return task.getExecutionEndTime();
-	}
-
-	public DateTime getExecutionStartTime() throws NoSuchFieldException {
-		return task.getExecutionStartTime();
-	}
-
-	public ReadableDuration getExpectedDuration() throws NoSuchFieldException {
-		return task.getExpectedDuration();
-	}
-
+		init();
+	}
+	
+	protected void init() {
+		double currentTime =  DateTimeUtilsExt.getDateTimeAt(arrivalTime).getMillis() / 1000;
+		this.submissionTime =  currentTime;
+        this.totalCompletionTime = 0.0;
+	 }
+	
+	public int getUserId() {
+		return task.getSenderId();
+	}
+	public String getUserDN() {
+		return task.getUserDN();
+	}
+
+	public String getJobId() {
+		return task.getJobId();
+	}
+	
+	public String getTaskId(){
+		return this.task.getId();
+	}
+	
 	public String getId() {
 		if(processesSetId == null)
@@ -69,7 +103,195 @@
 			return task.getId() + "_" + processesSetId;
 	}
-
-	public String getJobId() {
-		return task.getJobId();
+	
+	public String getProcessesId(){
+		return this.processesSetId;
+	}
+	
+    public int getUniqueId(){
+    	if(processesSetId == null){
+    		return (task.getJobId() + "_" + task.getId()).hashCode();
+    	} else {
+    		return (task.getJobId() + "_" + task.getId() + "_" + processesSetId).hashCode();
+    	}
+    }
+    
+	public List<AbstractProcesses> getProcesses() {
+		return task.getProcesses();
+	}
+
+	public List<AbstractProcesses> getProcesses(
+			AbstractProcessesGroup processGroup) {
+		return task.getProcesses(processGroup);
+	}
+
+	public List<AbstractProcessesGroup> getProcessesGroups() {
+		return task.getProcessesGroups();
+	}
+
+	public org.qcg.broker.schemas.resreqs.Task getDescription() {
+		return task.getDescription();
+	}
+
+	public String getDocument() throws Exception {
+		return task.getDocument();
+	}
+	
+	public long getLength() {
+		return task.getLength();
+	}
+
+	public int getStatus() {
+		return status;
+	}
+	
+	public boolean isFinished()
+    {
+		return task.isFinished();
+    }
+	
+	public void setStatus(int newStatus) throws Exception {
+		int prevStatus = status;
+	    
+        if (status == newStatus) {
+            return;
+        }
+
+        if (newStatus < DCWormsTags.CREATED || newStatus > DCWormsTags.FAILED_RESOURCE_UNAVAILABLE)
+        {
+            throw new Exception("Gridlet.setGridletStatus() : Error - " +
+                    "Invalid integer range for Gridlet status.");
+        }
+
+        status = newStatus;
+        double currentTime = DateTimeUtilsExt.currentTimeMillis() / 1000; // time in seconds 
+    
+		
+		if (newStatus == DCWormsTags.SUCCESS || newStatus == DCWormsTags.CANCELED) {
+            finishTime = DateTimeUtilsExt.currentTimeMillis() / 1000;
+        }
+		
+		if(newStatus == DCWormsTags.SUBMITTED){
+			 arrivalTime = GridSim.clock();
+		}
+
+        if (prevStatus == DCWormsTags.INEXEC)
+        {
+
+            if (status == DCWormsTags.CANCELED || status == DCWormsTags.PAUSED ||
+                status == DCWormsTags.SUCCESS)
+            {
+                totalCompletionTime += (currentTime -  execStartTime);
+            }
+        }
+
+        if (prevStatus == DCWormsTags.RESUMED && status == DCWormsTags.SUCCESS)
+        {
+            totalCompletionTime += (currentTime -  execStartTime);
+        }
+
+        if (status == DCWormsTags.INEXEC ||
+            (prevStatus == DCWormsTags.PAUSED && status == DCWormsTags.RESUMED) )
+        {
+        	execStartTime = currentTime;
+    		ProcessingElements pes = (ProcessingElements) getUsedResources().getLast().getResourceUnits().get(StandardResourceUnitName.PE);
+    		for (ComputingResource resource : pes) {
+
+    			visitResource(resource.getName());
+    			ComputingResource parent = resource.getParent();
+
+				List<String> visitedResource = getVisitedResources();
+    			while (parent != null && !ArrayUtils.contains(visitedResource.toArray(new String[visitedResource.size()]), parent.getName())) {
+    				visitResource(parent.getName());
+    				parent = parent.getParent();
+    			}
+    		}
+        }
+	}
+	
+	public void addSpecificResource(ResourceParameterName resourceName, Object value){
+		if(this.specificResources == null)
+			this.specificResources = new HashMap<ResourceParameterName, Object>();
+		
+		this.specificResources.put(resourceName, value);
+	}
+
+	public boolean expectSpecificResource(ResourceParameterName resourceName){
+		if(this.specificResources == null)
+			return false;
+
+		return this.specificResources.containsKey(resourceName);
+	}
+	
+	public Object getExpectedSpecificResource(ResourceParameterName resourceName){
+		if(this.specificResources == null)
+			return null;
+		
+		return this.specificResources.get(resourceName);
+	}
+	
+	public void setReservationId(String reservationId){
+		this.reservationId = reservationId;
+	}
+	
+	public boolean requireReservation(){
+		return (reservationId != null);
+	}
+	
+	public String getReservationId(){
+		return this.reservationId;
+	}
+	
+	public double getCompletionPercentage() {
+		return completionPercentage;
+	}
+
+	public void setCompletionPercentage(double completionPercentage) {
+		this.completionPercentage = completionPercentage;
+	}
+
+	public void addUsedResources(ResourceHistoryItem usedResources){
+		this.usedResources.add(usedResources);
+	}
+	
+	public UsedResourceList<ResourceHistoryItem> getUsedResources(){
+		return this.usedResources;
+	}
+	
+    public void setSchedulerName(int resourceId)
+    {
+        this.schedName = GridSim.getEntityName(resourceId);
+    }
+
+    public String getSchedulerName()
+    {
+        return schedName;
+    }
+	
+	public int getEstimatedDuration(){
+		return this.estimatedDuration;
+	}
+	
+	public void setEstimatedDuration(int value){
+		this.estimatedDuration = value;
+	}
+
+	public boolean isRegistered() {
+		return task.isRegistered();
+	}
+
+	public void register(JobRegistryImpl jobRegistry) {
+		task.register(jobRegistry);
+	}
+	
+	public void visitResource(String resName){
+		visitedResources.add(resName);
+	}
+	
+	public List<String> getVisitedResources(){
+		return visitedResources;
+	}
+	
+	public ReadableDuration getExpectedDuration() throws NoSuchFieldException {
+		return task.getExpectedDuration();
 	}
 
@@ -83,4 +305,20 @@
 		return task.getParameterStringValue(parameterName);
 	}
+	
+	public double getCpuCntRequest() throws NoSuchFieldException{
+		return getParameterDoubleValue(ResourceParameterName.CPUCOUNT);
+	}
+	
+	public double getMemoryRequest() throws NoSuchFieldException{
+		return getParameterDoubleValue(ResourceParameterName.MEMORY);
+	}
+	
+	public DateTime getExecutionEndTime() throws NoSuchFieldException {
+		return task.getExecutionEndTime();
+	}
+
+	public DateTime getExecutionStartTime() throws NoSuchFieldException {
+		return task.getExecutionStartTime();
+	}
 
 	public DateTime getSubmissionTimeToBroker() {
@@ -88,82 +326,34 @@
 	}
 
-	public String getUserDN() {
-		return task.getUserDN();
-	}
-
-	public List<AbstractProcesses> getProcesses() {
-		return task.getProcesses();
-	}
-
-	public List<AbstractProcesses> getProcesses(
-			AbstractProcessesGroup processGroup) {
-		return task.getProcesses(processGroup);
-	}
-
-	public List<AbstractProcessesGroup> getProcessesGroups() {
-		return task.getProcessesGroups();
-	}
-
-	public org.qcg.broker.schemas.resreqs.Task getDescription() {
-		return task.getDescription();
-	}
-
-	public String getDocument() throws Exception {
-		return task.getDocument();
-	}
-	
-	public void setReservationId(String reservationId){
-		this.reservationId = reservationId;
-	}
-	
-	public String getProcessesId(){
-		return this.processesSetId;
-	}
-	
-	public String getTaskId(){
-		return this.task.getId();
-	}
-	
-	public void addSpecificResource(ResourceParameterName resourceName, Object value){
-		if(this.chosenResources == null)
-			this.chosenResources = new HashMap<ResourceParameterName, Object>();
-		
-		this.chosenResources.put(resourceName, value);
-	}
-
 	public long getWorkloadLogWaitTime() {
 		return task.getWorkloadLogWaitTime();
 	}
-	
-	
-	/*public void addToResPath(String resName){
-		task.addToResPath(resName);
-	}
-	
-	public String getResPath(){
-		return task.getResPath();
-	}
-	*/
-	
-	public void visitResource(String resName){
-		visitedResources.add(resName);
-	}
-	
-	public List<String> getVisitedResources(){
-		return visitedResources;
-	}
-	
-	
-	protected String reservationId;
-	
-	public boolean requireReservation(){
-		return (reservationId != null);
-	}
-	
-	public String getReservationId(){
-		return this.reservationId;
-	}
-	
-	
+
+    public double getExecStartTime() {
+        return execStartTime;
+    }
+
+    public double getFinishTime() {
+        return finishTime;
+    }
+
+    public double getSubmissionTime() {
+        return submissionTime;
+    }
+    
+    public double getWaitingTime()
+    {
+        return execStartTime - submissionTime;
+    }
+
+    
+    public void finalizeExecutable(){
+
+    }
+    
+	public void accept(WorkloadUnitHandler wuh) {
+		wuh.handleExecutable(this);
+	}
+    
 	public boolean equals(Object obj){
 		if(obj instanceof Executable){
@@ -173,117 +363,4 @@
 		return false;
 	}
-	
-	public void setGridletStatus(int newStatus) throws Exception {
-		if(status_ == newStatus)
-			return;
-		
-		super.setGridletStatus(newStatus);
-		
-		if (newStatus == Gridlet.SUCCESS || newStatus == Gridlet.CANCELED) {
-            finishTime_ = DateTimeUtilsExt.currentTimeMillis() / 1000;
-        }
-	}
-
-	/**
-	 * @return the sum of the actual CPU time values for every gird resource, 
-	 * that this sub task has been executed on
-	 */
-	public double getTotalProcessingTime() {
-		double totalProcessingTime = 0.0;
-		for (Object resObj : resList_) {
-			Resource res = (Resource) resObj;
-			totalProcessingTime += res.actualCPUTime;
-		}
-		return totalProcessingTime;
-	}
-	
-
-	protected Map<ResourceParameterName, Object> chosenResources;
-
-	
-	/**
-	 * 
-	 * @return length measured in instructions.
-	 */
-	public long getLength() {
-		return Double.valueOf(getGridletLength()).longValue();
-	}
-	
-	/**
-	 * 
-	 * @param length measured in instructions.
-	 */
-	public void setLength(long length){
-		setGridletLength(Long.valueOf(length).doubleValue());
-	}
-	
-	/**
-	 * 
-	 * @return constant which represent current task status
-	 */
-	public int getStatus() {
-		return getGridletStatus();
-	}
-	
-	/**
-	 * 
-	 * @param status constant which describes current new task status
-	 */
-	public void setStatus(int status) throws Exception {
-		setGridletStatus(status);
-	}
-	
-	public double getCpuCntRequest() throws NoSuchFieldException{
-		return getParameterDoubleValue(ResourceParameterName.CPUCOUNT);
-	}
-	
-	public double getMemoryRequest() throws NoSuchFieldException{
-		return getParameterDoubleValue(ResourceParameterName.MEMORY);
-	}
-	
-	public boolean isFinished()
-    {
-        if (index_ == -1) {
-            return false;
-        }
-
-        boolean completed = false;
-
-        // if result is 0 or -ve then this Gridlet has finished
-        double finish = ( (Resource) resList_.get(index_) ).finishedSoFar;
-        double result = gridletLength_ - finish;
-        if (result <= 0.001) {
-            completed = true;
-        }
-
-        return completed;
-    }
-	
-	public boolean expectSpecificResource(ResourceParameterName resourceName){
-		if(this.chosenResources == null)
-			return false;
-
-		return this.chosenResources.containsKey(resourceName);
-	}
-	
-	public Object getExpectedSpecificResource(ResourceParameterName resourceName){
-		if(this.chosenResources == null)
-			return null;
-		
-		return this.chosenResources.get(resourceName);
-	}
-	
-	public boolean isRegistered() {
-		return task.isRegistered();
-	}
-
-	public void register(JobRegistryImpl jobRegistry) {
-		task.register(jobRegistry);
-
-	}
-	
-	@Override
-	public void accept(WorkloadUnitHandler wuh) {
-		wuh.handleExecutable(this);
-	}
+
 }
Index: /DCWoRMS/trunk/src/example/localplugin/BaseLocalSchedulingPlugin.java
===================================================================
--- /DCWoRMS/trunk/src/example/localplugin/BaseLocalSchedulingPlugin.java	(revision 478)
+++ /DCWoRMS/trunk/src/example/localplugin/BaseLocalSchedulingPlugin.java	(revision 481)
@@ -10,5 +10,5 @@
 import schedframe.resources.units.ResourceUnit;
 import schedframe.resources.units.ResourceUnitName;
-import schedframe.scheduling.WorkloadUnitListImpl;
+import schedframe.scheduling.TaskListImpl;
 import schedframe.scheduling.manager.resources.ResourceManager;
 import schedframe.scheduling.manager.tasks.JobRegistryImpl;
@@ -22,5 +22,4 @@
 import schedframe.scheduling.queue.TaskQueueList;
 import schedframe.scheduling.tasks.TaskInterface;
-import schedframe.scheduling.tasks.WorkloadUnit;
 import schemas.StringValueWithUnit;
 
@@ -46,5 +45,5 @@
 	}
 	
-	public int placeJobsInQueues(WorkloadUnitListImpl newJobs,
+	public int placeTasksInQueues(TaskListImpl newTasks,
 			TaskQueueList queues, 
 			ResourceManager resourceManager, ModuleList moduleList) {
@@ -53,6 +52,6 @@
 		TaskQueue queue = queues.get(0);
 
-		for(int i = 0; i < newJobs.size(); i++){
-			WorkloadUnit task = newJobs.get(i);
+		for(int i = 0; i < newTasks.size(); i++){
+			TaskInterface<?> task = newTasks.get(i);
 			queue.add(task);
 		}
